grails-app/domain/net/okjsp/Article.groovy
package net.okjsp

import grails.transaction.Transactional

import java.text.Normalizer

class Article {

    transient articleService

    String title
    String tagString

    Integer viewCount = 0
    Integer voteCount = 0
    Integer noteCount = 0
    Integer scrapCount = 0
    boolean enabled = true
    boolean choice = false

    Category category

    Avatar author
    Avatar lastEditor

    boolean anonymity = false
    String aNickName

    Content selectedNote

    String createIp = ""

    Date dateCreated
    Date lastUpdated

    Integer best = 0

    boolean disabled
    boolean ignore

    boolean isRecruit = false
    boolean ignoreBest = false

    Recruit recruit

    static belongsTo = [content: Content]

    static hasMany = [tags : Tag, notes: Content, articleNotices: ArticleNotice]

    static transients = ['disabled', 'recruit', 'ignore']

    static mapping = {
        notes sort: 'id', order: 'asc'
        sort id: 'desc'
        best formula: "view_count + vote_count * 500 + note_count * 50"
    }

    static constraints = {
        title blank: false
        author nullable: true, bindable: false
        lastEditor nullable: true, bindable: false
        aNickName nullable: true
        viewCount bindable: false
        voteCount bindable: false
        noteCount bindable: false
        scrapCount bindable: false
        tags maxSize: 10, nullable: true
        tagString nullable: true
        notes bindable: false
        enabled bindable: false
        selectedNote nullable: true, bindable: false
        content nullable: true
        choice bindable: false, nullable: true
        createIp bindable: false, nullable: true
        ignoreBest bindable: false, nullable: true
        title validator: { val ->
            def spam = SpamWord.findAll().find { word ->
                val.contains(word.text)
            }

            if(spam) return ["default.invalid.word.message"]
        }
    }

    def getDisplayAuthor() {
        if(anonymity) {
            return new Avatar(
                nickname: aNickName ?: "익명",
                picture: '',
                pictureType: AvatarPictureType.ANONYMOUSE,
                activityPoint: null
            )
        } else {
            return author
        }
    }

    def beforeInsert() {
        if(anonymity) {
            author = null
            content.anonymity = true
            content.author = null
            content.aNickName = aNickName
        }
        updateTag()
    }

    def beforeUpdate() {
        if(anonymity) {
            author = null
            lastEditor = null
            content.anonymity = true
            content.aNickName = aNickName
        }
        if(isDirty('tagString')) {
            updateTag()
            articleService.changeLog(ChangeLogType.TAGS, this, content, this.getPersistentValue('tagString'), tagString)
        }
        if(isDirty('title')) {
            articleService.changeLog(ChangeLogType.TITLE, this, content, this.getPersistentValue('title'), title)
        }
    }

    def beforeDelete() {
        /*if(tags) {
            tags.each { tag ->
                tag.taggedCount--
                tag.save()
            }
        }*/
    }

    void updateTag() {

        def removedTags = tags ?: []

        if(tagString) {
            def tagNames = tagString.split(/[,\s]+/).toList().unique().findAll { !it.isEmpty() }

            tagNames.each { tagName ->
                tagName = tagName.toLowerCase()
                def tag = TagSimilarText.findByText(tagName)?.tag ?: Tag.findByName(tagName)

                if(tag == null) {
                    tag =  new Tag(name: tagName).save()
                } else {
                    if(!tags?.contains(tag))
                        tag.taggedCount++
                }

                addToTags(tag)
                removedTags -= tag
                tag.save()
            }

            tagString = tagNames.join(',')
        }

        removedTags.each { tag ->
            removeFromTags(tag)
            tag.taggedCount--
            tag.save()
        }
    }

    /*
        Custom queries
     */
    @Transactional
    def updateViewCount(def i) {
        if(id != null) {
            executeUpdate("update Article set viewCount = viewCount+:i where id = :id",[i:i, id: id])
        }
    }

    @Transactional
    def updateNoteCount(def i) {
        if(id != null) {
            executeUpdate("update Article set noteCount = noteCount+:i where id = :id",[i:i, id: id])
        }
    }

    @Transactional
    def updateVoteCount(def i) {
        if(id != null) {
            executeUpdate("update Article set voteCount = voteCount+:i where id = :id",[i:i, id: id])
        }
    }

    @Transactional
    def updateScrapCount(def i) {
        if(id != null) {
            executeUpdate("update Article set scrapCount = scrapCount+:i where id = :id",[i:i, id: id])
        }
    }

    String toString() {
        return "#${id} - ${title}"
    }
}

grails-app/domain/net/okjsp/User.groovy
package net.okjsp

import grails.util.Environment

class User {

	transient springSecurityService

	String username
	String password
	boolean enabled = false
	boolean accountExpired = false
	boolean accountLocked = false
	boolean passwordExpired = false
	boolean withdraw = false

    Date lastPasswordChanged = new Date()

    Date dateCreated
    Date lastUpdated
	Date dateWithdraw

    Person person
    Avatar avatar

    String createIp
    String lastUpdateIp

	String dateJoined

	String oid

    static hasMany = [loggedIns: LoggedIn, oAuthIDs: OAuthID]

	static transients = ['springSecurityService']

	static constraints = {
		username(blank: false, unique: true, size: 4..15, matches: /[a-z0-9]{4,15}/, validator: {
            if(disAllowUsernameFilter(it)) return ['default.invalid.disallow.message']
        })
		password blank: false, minSize: 6, matches: /^(?=.*[0-9])(?=.*[a-zA-Z]).*$/
        person unique: true
        avatar unique: true
        enabled bindable: false
        accountExpired bindable: false
        accountLocked bindable: false
        passwordExpired bindable: false
        lastPasswordChanged bindable: false
        loggedIns bindable: false
        createIp bindable: false, nullable: true
        lastUpdateIp nullable: true, bindable: false
		dateWithdraw bindable: false, nullable: true
		withdraw bindable: false, nullable: true
		oid bindable: false, nullable: true
	}

	static mapping = {
		password column: '`password`'

		loggedIns sort:'id', order:'desc'

		if (Environment.current == Environment.DEVELOPMENT)
			dateJoined formula: "FORMATDATETIME(date_created, 'yyyy-MM-dd')"

		if (Environment.current == Environment.PRODUCTION)
			dateJoined formula: "DATE_FORMAT(date_created, '%Y-%m-%d')"
	}

	Set<Role> getAuthorities() {
		UserRole.findAllByUser(this).collect { it.role }
	}

	def beforeInsert() {
		encodePassword()
	}

	def beforeUpdate() {
		if (isDirty('password')) {
			encodePassword()
		}
	}

    static boolean disAllowUsernameFilter(username) {
        return ['root','administrator','administration','rootadmin','adminroot'
            ,'system','tomcatroot','sysadmin','sysroot','manager','management','manage'].contains(username)
    }

	protected void encodePassword() {
		password = springSecurityService?.passwordEncoder ? springSecurityService.encodePassword(password) : password
	}
}

grails-app/controllers/net/okjsp/UserController.groovy
package net.okjsp

import com.megatome.grails.RecaptchaService
import grails.plugin.mail.MailService
import grails.plugin.springsecurity.SpringSecurityService
import grails.plugin.springsecurity.SpringSecurityUtils
import grails.plugin.springsecurity.annotation.Secured
import grails.util.Environment
import grails.validation.ValidationException

import static org.springframework.http.HttpStatus.*
import grails.transaction.Transactional

@Transactional(readOnly = true)
class UserController {

    UserService userService
    RecaptchaService recaptchaService
    SpringSecurityService springSecurityService
    MailService mailService
    EncryptService encryptService

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    def beforeInterceptor = [action:this.&notLoggedIn,
                             except: ['edit', 'update', 'index', 'rejectDM', 'withdrawConfirm', 'withdraw', 'passwordChange', 'updatePasswordChange']]

    private notLoggedIn() {
        if(springSecurityService.loggedIn) {
            redirect uri: '/'
            return false
        }
    }

    def index(Integer id, Integer max) {
        params.max = Math.min(max ?: 20, 100)
        params.sort = params.sort ?: 'id'
        params.order = params.order ?: 'desc'

        Avatar currentAvatar = Avatar.get(id)
        User user = User.findByAvatar(currentAvatar)

        if(user.withdraw) {
            redirect uri: '/'
            return
        }

        def activitiesQuery

        if(params.category == 'activity' || (!params.category && !currentAvatar.official)) {
            activitiesQuery= Activity.where {
                avatar == currentAvatar
            }
        } else {
            def category

            if(params.category == 'solved') category = ActivityType.SOLVED
            else if(params.category == 'scrapped') category = ActivityType.SCRAPED
            else {
                params.category = 'articles'
                category = ActivityType.POSTED
            }

            activitiesQuery= Activity.where {
                avatar == currentAvatar
                type == category
            }
        }

        def counts = [
            postedCount: Activity.countByAvatarAndType(currentAvatar, ActivityType.POSTED),
            solvedCount: Activity.countByAvatarAndType(currentAvatar, ActivityType.SOLVED),
            followerCount : Follow.countByFollowing(currentAvatar),
            followingCount : Follow.countByFollower(currentAvatar),
            scrappedCount : Scrap.countByAvatar(currentAvatar)
        ]

        respond user, model: [avatar: currentAvatar, activities: activitiesQuery.list(params), activitiesCount: activitiesQuery.count(), counts: counts]
    }

    def register() {
        recaptchaService.cleanUp session
        respond new User(params)
    }

    @Transactional
    def save(User user) {

        try {

            def realIp = userService.getRealIp(request)

            def reCaptchaVerified = recaptchaService.verifyAnswer(session, realIp, params)

            if(!reCaptchaVerified) {
                respond user.errors, view: 'register'
                return
            }

            user.createIp = realIp

            userService.saveUser user

            recaptchaService.cleanUp session

            def key = userService.createConfirmEmail(user)

            mailService.sendMail {
                async true
                to user.person.email
                subject message(code:'email.join.subject')
                body(view:'/email/join_confirm', model: [user: user, key: key, grailsApplication: grailsApplication] )
            }

            session['confirmSecuredKey'] = key

            request.withFormat {
                form multipartForm {
                    flash.message = message(code: 'default.created.message', args: [message(code: 'user.label', default: 'User'), user.id])
                    redirect action: 'complete'
                }
                '*' { respond user, [status: CREATED] }
            }

        } catch (ValidationException e) {
            respond user.errors, view: 'register'
        }
    }

    def complete() {

        if(springSecurityService.isLoggedIn()) {
            redirect uri: "/"
            return
        }

        def confirmEmail = ConfirmEmail.where {
            securedKey == session['confirmSecuredKey'] &&
                dateExpired > new Date()
        }.get()

        if(!confirmEmail) {
            flash.message = message(code: 'default.expired.link.message')
            redirect uri: '/login/auth'
            return
        }

        render view: 'complete', model: [email: confirmEmail.email]
    }

    @Transactional
    def confirm(String key) {

        if(springSecurityService.isLoggedIn()) {
            redirect uri: "/"
            return
        }

        session.invalidate()

        def confirmEmail = ConfirmEmail.where {
            securedKey == key &&
                dateExpired > new Date()
        }.get()

        if(!confirmEmail) {
            flash.message = message(code: 'default.expired.link.message')
            redirect uri: '/login/auth'
            return
        }

        User user = confirmEmail.user

        user.person.email = confirmEmail.email
        user.person.save()

        user.enabled = true
        user.save()

        confirmEmail.delete(flush: true)

        render view: 'confirm'
    }

    def edit() {
        User user = springSecurityService.currentUser

        Company company = Company.findByManager(user.person)

        respond user, model: [company: company]
    }

    @Transactional
    def update(User user) {
        if (user == null) {
            notFound()
            return
        }

        if (user.hasErrors()) {
            respond user.errors, view:'edit'
            return
        }
        
        try {

            userService.updateUser user

            request.withFormat {
                form multipartForm {
                    flash.message = message(code: 'default.updated.message', args: [message(code: 'User.label', default: 'User'), user.id])
                    redirect action: 'edit'
                }
                '*'{ respond user, [status: OK] }
            }

        } catch (ValidationException e) {
            user.oAuthIDs = OAuthID.findAllByUser(user)
            respond user.errors, view: 'edit'
        }
    }

    def password(String key) {

        if(springSecurityService.isLoggedIn()) {
            redirect uri: "/"
            return
        }

        def confirmEmail = ConfirmEmail.where {
            securedKey == key &&
                dateExpired > new Date()
        }.get()

        if(!confirmEmail) {
            flash.message = message(code: 'default.expired.link.message')
            redirect uri: '/login/auth'
            return
        }

        render view: 'password', model: [key: key]

    }
    
    @Transactional
    def updatePassword(String password, String passwordConfirm, String key) {

        if(springSecurityService.isLoggedIn()) {
            redirect uri: "/"
            return
        }

        def confirmEmail = ConfirmEmail.where {
            securedKey == key &&
                dateExpired > new Date()
        }.get()

        if(!confirmEmail) {
            flash.message = message(code: 'default.expired.link.message')
            redirect uri: '/login/auth'
            return
        }

        if(password != passwordConfirm) {
            flash.message = message(code: 'user.password.not.equal.message')
            render view: 'password', model: [key: key]
            return
        }

        def user = confirmEmail.user

        user.password = password
        user.enabled = true
        user.save()

        if(user.hasErrors()) {
            flash.message = message(code: 'user.password.matches.error', args: [message(code: 'user.password.label')])
            render view: 'password', model: [key: key]
            return
        }

        confirmEmail.delete(flush: true)

        flash.message = message(code: 'user.password.updated.message')
        redirect uri: '/login/auth'
    }
    
    @Transactional
    def rejectDM(String k) {
        
        String email = "", result = "실패"
        
        try {
            email = new String(encryptService.decrypt(k.getBytes()))
        } catch(Exception e) {
            e.printStackTrace()
        }
        
        Person p = Person.findByEmail(email)
        if(p != null) {
            p.setDmAllowed(false)
            p.save()
            result = "성공"
        }
        
        render "수신거부에 ${result}하였습니다."
    }

    def withdrawConfirm() {
        render view: "withdrawConfirm"
    }

    @Transactional
    def withdraw() {
        User user = springSecurityService.currentUser

        userService.withdraw(user)

        session.invalidate()

        redirect controller: 'user', action: 'withdrawComplete'

    }

    def withdrawComplete() {
        render view: "withdrawComplete"
    }

    def passwordChange() {
        render view: "passwordChange"
    }

    @Transactional
    def updatePasswordChange(String oldPassword, String password, String passwordConfirm, String key) {

        User user = springSecurityService.currentUser

        if(user.password != springSecurityService.encodePassword(oldPassword)) {
            flash.message = message(code: 'user.oldPassword.not.equal.message')
            render view: 'passwordChange'
            return
        }

        if(password != passwordConfirm) {
            flash.message = message(code: 'user.password.not.equal.message')
            render view: 'passwordChange', model: [key: key]
            return
        }

        user.password = password
        user.save()

        if(user.hasErrors()) {
            flash.message = message(code: 'user.password.matches.error', args: [message(code: 'user.password.label')])

grails-app/views/user/articles.gsp
<%@ page import="net.okjsp.User" %>
<%@ page import="net.okjsp.Activity" %>
<%@ page import="net.okjsp.Content" %>
<%@ page import="net.okjsp.ContentType" %>
<%@ page import="net.okjsp.ActivityType" %>
<!DOCTYPE html>
<html>
	<head>
		<meta name="layout" content="main">
		<g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
		<title><g:message code="default.show.label" args="[entityName]" /></title>
	</head>
	<body>
        <g:sidebar/>
        <div id="user" class="content clearfix" role="main">
            <div class="panel panel-default">
                <div class="panel-body">
                    <g:avatar size="big" avatar="${avatar}" pictureOnly="true" class="col-sm-3 text-center" />
                    <div class="user-info col-sm-9">
                        <div class="clearfix">
                            <h2 class="pull-left">${avatar.nickname}</h2>
                            <button class="btn btn-success pull-right btn-wide disabled"><i class="fa fa-plus"></i> 팔로우</button>
                        </div>
                        <div class="user-points">
                            <div class="user-point">
                                <div class="user-point-label"><i class="fa fa-flash"></i> 활동점수</div>
                                <div class="user-point-num"><a href="#">${avatar.activityPoint}</a></div>
                            </div>
                            <div class="user-point">
                                <div class="user-point-label"><i class="fa fa-user"></i> 팔로잉</div>
                                <div class="user-point-num"><a href="#">${counts.followingCount}</a></div>
                            </div>
                            <div class="user-point">
                                <div class="user-point-label"><i class="fa fa-users"></i> 팔로워</div>
                                <div class="user-point-num"><a href="#">${counts.followerCount}</a></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            %{--<div class="col-sm-2 user-info-nav">
                <ul class="nav">
                    <li class="active"><g:link uri="/user/info/2">최근 활동</g:link> </li>
                    <li><g:link uri="/user/info/2/articles"><g:if test="${counts.postedCount > 0}"><span class="badge">${counts.postedCount}</span></g:if> 게시물</g:link></li>
                    <li><g:link uri="/user/info/2/solved"><g:if test="${counts.solvedCount > 0}"><span class="badge">${counts.solvedCount}</span></g:if> 질문 해결</g:link></li>
                    <li><g:link uri="/user/info/2/scrapped"><g:if test="${counts.scrappedCount > 0}"><span class="badge">${counts.scrappedCount}</span></g:if> 스크랩</g:link></li>
                </ul>
            </div>--}%
            <div class="col-sm-10 main-block-left">
                <ul class="list-group">

                    <g:if test="${articlesCount == 0}">
                        <li class="list-group-item clearfix">
                            <div class="panel-body text-center">
                                글이 없습니다.
                            </div>
                        </li>
                    </g:if>

                    <g:each in="${articleList}" status="i" var="article">

                        <g:set var="evaluateClass" value="no-note" />

                        <g:if test="${article.selectedNote}">
                            <g:set var="evaluateClass" value="success" />
                        </g:if>
                        <g:elseif test="${article.noteCount > 0}">
                            <g:set var="evaluateClass" value="has-note" />
                        </g:elseif>

                        <li class="list-group-item ${category?.useEvaluate ? 'list-group-item-question':''} list-group-${evaluateClass} clearfix">

                            <div class="list-title-wrapper clearfix">
                                <div class="list-tag clearfix">
                                    <span class="list-group-item-text article-id">#${article.id}</span>
                                    <g:categoryLabel category="${article.category}" />
                                    <g:tags tags="${article.tagString}" />
                                </div>

                                <h5 class="list-group-item-heading ${category?.useEvaluate ? 'list-group-item-evaluate' : ''}">
                                    <g:link controller="article" action="show" id="${article.id}">${fieldValue(bean: article, field: "title")}</g:link>
                                </h5>
                            </div>

                            <div class="list-summary-wrapper clearfix">
                                <g:if test="${category?.useEvaluate}">
                                    <div class="item-evaluate-wrapper pull-right clearfix">
                                        <div class="item-evaluate">
                                            <div class="item-evaluate-icon">
                                                <i class="item-icon fa fa-thumbs-o-up"></i>
                                            </div>
                                            <div class="item-evaluate-count">
                                                <span><g:shorten number="${article.voteCount}" />
                                            </div>
                                        </div>
                                        <div class="item-evaluate item-evaluate-${evaluateClass}">
                                            <div class="item-evaluate-icon">
                                                <g:if test="${evaluateClass == 'no-note'}">
                                                    <i class="item-icon fa fa-question-circle"></i>
                                                </g:if>
                                                <g:elseif test="${evaluateClass == 'has-note'}">
                                                    <i class="item-icon fa fa-exclamation-circle"></i>
                                                </g:elseif>
                                                <g:elseif test="${evaluateClass == 'success'}">
                                                    <i class="item-icon fa fa-check-circle"></i>
                                                </g:elseif>
                                            </div>
                                            <div class="item-evaluate-count">
                                                <g:shorten number="${article.noteCount}" />
                                            </div>
                                        </div>
                                    </div>
                                </g:if>
                                <g:else>
                                    <div class="list-group-item-summary clearfix">
                                        <ul>
                                            <li class="${article.noteCount == 0 ? 'item-icon-disabled' : ''}"><i class="item-icon fa fa-comment "></i> <g:shorten number="${article.noteCount}" /></li>
                                            <li class="${article.voteCount == 0 ? 'item-icon-disabled' : ''}"><i class="item-icon fa fa-thumbs-up"></i> <g:shorten number="${article.voteCount}" /></li>
                                            <li class="${article.viewCount == 0 ? 'item-icon-disabled' : ''}"><i class="item-icon fa fa-eye"></i> <g:shorten number="${article.viewCount}" /></li>
                                        </ul>
                                    </div>
                                </g:else>
                            </div>

                            <div class="list-group-item-author clearfix">
                                <g:avatar avatar="${article.displayAuthor}" size="list" dateCreated="${article.dateCreated}" />
                            </div>
                        </li>
                    </g:each>
                </ul>
                <div class="text-center">
                    <g:if test="${activitiesCount > 0}">
                        <g:paginate controller="user" action="index" id="${avatar.id}" class="pagination-sm" total="${activitiesCount ?: 0}" />
                    </g:if>
                </div>
            </div>
            <div class="col-sm-2 user-info-nav">
                <ul class="nav">
                    <li><g:link uri="/user/info/${avatar.id}">최근 활동</g:link> </li>
                    <li class="active"><g:link uri="/user/articles/${avatar.id}">게시물 <g:if test="${counts.postedCount > 0}"><span class="badge">${counts.postedCount}</span></g:if></g:link></li>
                    <li><g:link uri="/user/scraps/${avatar.id}">스크랩 <g:if test="${counts.scrappedCount > 0}"><span class="badge">${counts.scrappedCount}</span></g:if></g:link></li>
                </ul>
            </div>
        </div>
	</body>
</html>

grails-app/views/user/complete.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main">
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
    <title><g:message code="default.create.label" args="[entityName]" /></title>
</head>
<body>
<g:sidebar/>

<div id="create-user" class="content" role="main">
    <h3 class="content-header">회원가입</h3>
    <div class="panel panel-default panel-margin-10">
        <div class="panel-body panel-body-content text-center">
            <p class="lead"><strong>${email}</strong> 로 인증 요청 메일을 보냈습니다.<br/>
                해당 이메일을 확인 하시고, 인증 확인 링크를 눌러 주시기 바랍니다.</p>
            <p>이메일 인증이 완료 되지 않을 경우 사이트 이용에 제한이 있습니다.</p>
            <p><strong>※ 서비스에 따라 스팸으로 분류 되있을 수도 있습니다. 스팸함도 꼭 확인해 주시기 바랍니다.</strong></p>

            <g:link controller="login" action="auth" class="btn btn-primary">로그인</g:link>

            %{--혹시, 인증 요청 메일이 수신 되지 않았을 경우 <a href="#">인증 메일 다시 보내기</a>를 눌러 주시기 바랍니다.</p>--}%
            %{--<a class="btn btn-default">이메일 주소 변경</a> <a class="btn btn-primary">인증 메일 다시 보내기</a>--}%
        </div>
    </div>
</div>
</body>
</html>

grails-app/views/user/confirm.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main">
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
    <title><g:message code="default.create.label" args="[entityName]" /></title>
</head>
<body>
<g:sidebar/>

<div id="create-user" class="content" role="main">
    <h3 class="content-header">이메일 인증</h3>
    <div class="panel panel-default panel-margin-10">
        <div class="panel-body panel-body-content text-center">
            <p class="lead">이메일 인증이 완료되었습니다</p>
            <p>이제 해당 계정 및 이메일 사용이 가능합니다. 로그인 후 이용해 주시기 바랍니다.</p>
            <g:link controller="login" action="auth" class="btn btn-primary">로그인</g:link>
        </div>
    </div>
</div>
</body>
</html>

grails-app/views/user/password.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main">
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
    <title><g:message code="default.create.label" args="[entityName]" /></title>
</head>
<body>
<g:sidebar/>

<div id="create-user" class="content" role="main">
    <h3 class="content-header">비밀번호 변경</h3>
    <g:form action="updatePassword" method="post">
    <div class="col-sm-8 col-sm-offset-2">
        <div class="panel panel-default panel-margin-10">
            <div class="panel-body panel-body-content text-center">
                <p class="lead">변경하실 비밀번호를 입력해 주세요.</p>
                <g:if test='${flash.message}'>
                    <div  class="alert alert-danger" role="alert">
                        <ul>
                            <li class="text-left">${flash.message}</li>
                        </ul>
                    </div>
                </g:if>
                <input type="hidden" name="key" value="${key}" />
                <div class="form-group">
                    <input type="password" name="password" class="form-control form-control-inline text-center" placeholder="비밀번호" />
                </div>
                <div class="form-group">
                    <input type="password" name="passwordConfirm" class="form-control form-control-inline text-center" placeholder="비밀번호 확인" />
                </div>
                <button type="submit" class="btn btn-primary">비밀번호 변경</button> <g:link uri="/" class="btn btn-default">취소</g:link>
            </div>
        </div>
    </div>
    </g:form>
</div>
</body>
</html>

grails-app/views/user/passwordChange.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main">
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
    <title><g:message code="default.create.label" args="[entityName]" /></title>
</head>
<body>
<g:sidebar/>

<div id="create-user" class="content" role="main">
    <h3 class="content-header">비밀번호 변경</h3>
    <g:form action="updatePasswordChange" method="post">
    <div class="col-sm-8 col-sm-offset-2">
        <div class="panel panel-default panel-margin-10">
            <div class="panel-body panel-body-content text-center">
                <p class="lead">변경하실 비밀번호를 입력해 주세요.</p>
                <g:if test='${flash.message}'>
                    <div  class="alert alert-danger" role="alert">
                        <ul>
                            <li class="text-left">${flash.message}</li>
                        </ul>
                    </div>
                </g:if>
                <div class="form-group">
                    <input type="password" name="oldPassword" class="form-control form-control-inline text-center" placeholder="현재 비밀번호" />
                </div>
                <div class="form-group">
                    <input type="password" name="password" class="form-control form-control-inline text-center" placeholder="새 비밀번호" />
                </div>
                <div class="form-group">
                    <input type="password" name="passwordConfirm" class="form-control form-control-inline text-center" placeholder="새 비밀번호 확인" />
                </div>
                <button type="submit" class="btn btn-primary">비밀번호 변경</button> <g:link uri="/" class="btn btn-default">취소</g:link>
            </div>
        </div>
    </div>
    </g:form>
</div>
</body>
</html>